ViewVC Help
View File | Revision Log | Show Annotations | Download File | Root Listing
root/radiance/ray/src/util/genBSDF.pl
(Generate patch)

Comparing ray/src/util/genBSDF.pl (file contents):
Revision 2.35 by greg, Wed May 9 17:40:17 2012 UTC vs.
Revision 2.90 by greg, Fri Sep 22 18:01:32 2023 UTC

# Line 6 | Line 6
6   #       G. Ward
7   #
8   use strict;
9 + my $windoz = ($^O eq "MSWin32" or $^O eq "MSWin64");
10   use File::Temp qw/ :mktemp  /;
11   sub userror {
12 <        print STDERR "Usage: genBSDF [-n Nproc][-c Nsamp][-t{3|4} Nlog2][-r \"ropts\"][-dim xmin xmax ymin ymax zmin zmax][{+|-}f][{+|-}b][{+|-}mgf][{+|-}geom units] [input ..]\n";
12 >        print STDERR "Usage: genBSDF [-n Nproc][-c Nsamp][-W][-t{3|4} Nlog2][-r \"ropts\"][-s \"x=string;y=string\"][-dim xmin xmax ymin ymax zmin zmax][{+|-}C][{+|-}a][{+|-}f][{+|-}b][{+|-}mgf][{+|-}geom units] [input ..]\n";
13          exit 1;
14   }
15 < my $td = mkdtemp("/tmp/genBSDF.XXXXXX");
16 < chomp $td;
15 > my ($td,$radscn,$mgfscn,$octree,$fsender,$bsender,$receivers,$facedat,$behinddat,$rmtmp);
16 > my ($tf,$rf,$tb,$rb,$tfx,$rfx,$tbx,$rbx,$tfz,$rfz,$tbz,$rbz);
17 > my ($curphase, $recovery);
18 > if ($#ARGV == 1 && "$ARGV[0]" =~ /^-rec/) {
19 >        $td = $ARGV[1];
20 >        open(MYAVH, "< $td/savedARGV.txt") or die "$td: invalid path\n";
21 >        @ARGV = <MYAVH>;
22 >        close MYAVH;
23 >        chomp @ARGV;
24 >        $recovery = 0;
25 >        if (open(MYPH, "< $td/phase.txt")) {
26 >                while (<MYPH>) {
27 >                        chomp($recovery = $_);
28 >                }
29 >                close MYPH;
30 >        }
31 > } elsif ($windoz) {
32 >        my $tmploc = `echo \%TMP\%`;
33 >        chomp $tmploc;
34 >        $td = mkdtemp("$tmploc\\genBSDF.XXXXXX");
35 > } else {
36 >        $td = mkdtemp("/tmp/genBSDF.XXXXXX");
37 >        chomp $td;
38 > }
39 > if ($windoz) {
40 >        $radscn = "$td\\device.rad";
41 >        $mgfscn = "$td\\device.mgf";
42 >        $octree = "$td\\device.oct";
43 >        $fsender = "$td\\fsender.rad";
44 >        $bsender = "$td\\bsender.rad";
45 >        $receivers = "$td\\receivers.rad";
46 >        $facedat = "$td\\face.dat";
47 >        $behinddat = "$td\\behind.dat";
48 >        $tf = "$td\\tf.dat";
49 >        $rf = "$td\\rf.dat";
50 >        $tb = "$td\\tb.dat";
51 >        $rb = "$td\\rb.dat";
52 >        $tfx = "$td\\tfx.dat";
53 >        $rfx = "$td\\rfx.dat";
54 >        $tbx = "$td\\tbx.dat";
55 >        $rbx = "$td\\rbx.dat";
56 >        $tfz = "$td\\tfz.dat";
57 >        $rfz = "$td\\rfz.dat";
58 >        $tbz = "$td\\tbz.dat";
59 >        $rbz = "$td\\rbz.dat";
60 >        $rmtmp = "rd /S /Q $td";
61 > } else {
62 >        $radscn = "$td/device.rad";
63 >        $mgfscn = "$td/device.mgf";
64 >        $octree = "$td/device.oct";
65 >        $fsender = "$td/fsender.rad";
66 >        $bsender = "$td/bsender.rad";
67 >        $receivers = "$td/receivers.rad";
68 >        $facedat = "$td/face.dat";
69 >        $behinddat = "$td/behind.dat";
70 >        $tf = "$td/tf.dat";
71 >        $rf = "$td/rf.dat";
72 >        $tb = "$td/tb.dat";
73 >        $rb = "$td/rb.dat";
74 >        $tfx = "$td/tfx.dat";
75 >        $rfx = "$td/rfx.dat";
76 >        $tbx = "$td/tbx.dat";
77 >        $rbx = "$td/rbx.dat";
78 >        $tfz = "$td/tfz.dat";
79 >        $rfz = "$td/rfz.dat";
80 >        $tbz = "$td/tbz.dat";
81 >        $rbz = "$td/rbz.dat";
82 >        $rmtmp = "rm -rf $td";
83 > }
84   my @savedARGV = @ARGV;
85 + my $rfluxmtx = "rfluxmtx -ab 5 -ad 700 -lw 3e-6 -w-";
86 + my $wrapper = "wrapBSDF";
87   my $tensortree = 0;
88   my $ttlog2 = 4;
89 + my $dorecip = 1;
90   my $nsamp = 2000;
20 my $rtargs = "-w -ab 5 -ad 700 -lw 3e-6";
91   my $mgfin = 0;
92   my $geout = 1;
93   my $nproc = 1;
94 + my $docolor = 0;
95   my $doforw = 0;
96   my $doback = 1;
97   my $pctcull = 90;
98 < my $gunit = "Meter";
98 > my $gunit = "meter";
99 > my $curspec = "Visible";
100   my @dim;
101   # Get options
102   while ($#ARGV >= 0) {
103          if ("$ARGV[0]" =~ /^[-+]m/) {
104                  $mgfin = ("$ARGV[0]" =~ /^\+/);
105          } elsif ("$ARGV[0]" eq "-r") {
106 <                $rtargs = "$rtargs $ARGV[1]";
106 >                $rfluxmtx .= " $ARGV[1]";
107                  shift @ARGV;
108          } elsif ("$ARGV[0]" =~ /^[-+]g/) {
109                  $geout = ("$ARGV[0]" =~ /^\+/);
# Line 40 | Line 112 | while ($#ARGV >= 0) {
112                          die "Illegal geometry unit '$gunit': must be meter, foot, inch, centimeter, or millimeter\n";
113                  }
114                  shift @ARGV;
115 +        } elsif ("$ARGV[0]" =~ /^[-+]C/) {
116 +                $docolor = ("$ARGV[0]" =~ /^\+/);
117 +        } elsif ("$ARGV[0]" =~ /^[-+]a/) {
118 +                $dorecip = ("$ARGV[0]" =~ /^\+/);
119          } elsif ("$ARGV[0]" =~ /^[-+]f/) {
120                  $doforw = ("$ARGV[0]" =~ /^\+/);
121          } elsif ("$ARGV[0]" =~ /^[-+]b/) {
# Line 47 | Line 123 | while ($#ARGV >= 0) {
123          } elsif ("$ARGV[0]" eq "-t") {
124                  # Use value < 0 for rttree_reduce bypass
125                  $pctcull = $ARGV[1];
126 +                if ($pctcull >= 100) {
127 +                        die "Illegal -t culling percentage, must be < 100\n";
128 +                }
129                  shift @ARGV;
130          } elsif ("$ARGV[0]" =~ /^-t[34]$/) {
131                  $tensortree = substr($ARGV[0], 2, 1);
132                  $ttlog2 = $ARGV[1];
133                  shift @ARGV;
134 +        } elsif ("$ARGV[0]" eq "-s") {
135 +                $wrapper .= " -f \"$ARGV[1]\"";
136 +                shift @ARGV;
137 +        } elsif ("$ARGV[0]" eq "-W") {
138 +                $wrapper .= " -W";
139          } elsif ("$ARGV[0]" eq "-c") {
140                  $nsamp = $ARGV[1];
141                  shift @ARGV;
# Line 71 | Line 155 | while ($#ARGV >= 0) {
155   }
156   # Check that we're actually being asked to do something
157   die "Must have at least one of +forward or +backward\n" if (!$doforw && !$doback);
158 < # Name our own persist file?
159 < my $persistfile;
160 < if ( $tensortree && $nproc > 1 && "$rtargs" !~ /-PP /) {
161 <        $persistfile = "$td/pfile.txt";
162 <        $rtargs = "-PP $persistfile $rtargs";
158 > $wrapper .= $tensortree ? " -a t$tensortree" : " -a kf -c";
159 > $wrapper .= " -u $gunit";
160 > if ( !defined $recovery ) {
161 >        # Issue warning for unhandled reciprocity case
162 >        print STDERR "Warning: recommend both +forward and +backward with -t3\n" if
163 >                        ($tensortree==3 && !($doforw && $doback));
164 >        # Get scene description
165 >        if ( $mgfin ) {
166 >                system "mgf2rad @ARGV > $radscn";
167 >                die "Could not load MGF input\n" if ( $? );
168 >        } else {
169 >                system "xform -e @ARGV > $radscn";
170 >                die "Could not load Radiance input\n" if ( $? );
171 >        }
172   }
173 < # Get scene description and dimensions
174 < my $radscn = "$td/device.rad";
82 < my $mgfscn = "$td/device.mgf";
83 < my $octree = "$td/device.oct";
84 < if ( $mgfin ) {
85 <        system "mgfilt '#,o,xf,c,cxy,cspec,cmix,m,sides,rd,td,rs,ts,ir,v,p,n,f,fh,sph,cyl,cone,prism,ring,torus' @ARGV > $mgfscn";
86 <        die "Could not load MGF input\n" if ( $? );
87 <        system "mgf2rad $mgfscn > $radscn";
88 < } else {
89 <        system "xform -e @ARGV > $radscn";
90 <        die "Could not load Radiance input\n" if ( $? );
91 <        system "rad2mgf $radscn > $mgfscn" if ( $geout );
173 > if ( $#dim != 5 ) {
174 >        @dim = split ' ', `getbbox -h -w $radscn`;
175   }
176 < if ($#dim != 5) {
177 <        @dim = split ' ', `getbbox -h $radscn`;
176 > die "Device entirely inside room!\n" if ( $dim[4] >= 0 );
177 > if ( $dim[5] > 1e-5 ) {
178 >        print STDERR "Warning: Device extends into room\n";
179 > } elsif ( $dim[5]*$dim[5] > .01*($dim[1]-$dim[0])*($dim[3]-$dim[2]) ) {
180 >        print STDERR "Warning: Device far behind Z==0 plane\n";
181   }
182 < print STDERR "Warning: Device extends into room\n" if ($dim[5] > 1e-5);
183 < # Add receiver surfaces (rectangular)
184 < my $fmodnm="receiver_face";
185 < my $bmodnm="receiver_behind";
186 < open(RADSCN, ">> $radscn");
187 < print RADSCN "void glow $fmodnm\n0\n0\n4 1 1 1 0\n\n";
188 < print RADSCN "$fmodnm source f_receiver\n0\n0\n4 0 0 1 180\n";
189 < print RADSCN "void glow $bmodnm\n0\n0\n4 1 1 1 0\n\n";
190 < print RADSCN "$bmodnm source b_receiver\n0\n0\n4 0 0 -1 180\n";
191 < close RADSCN;
192 < # Generate octree
193 < system "oconv -w $radscn > $octree";
108 < die "Could not compile scene\n" if ( $? );
109 < # Output XML prologue
110 < print
111 < '<?xml version="1.0" encoding="UTF-8"?>
112 < <WindowElement xmlns="http://windows.lbl.gov" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://windows.lbl.gov/BSDF-v1.4.xsd">
113 < ';
114 < print "<!-- File produced by: genBSDF @savedARGV -->\n";
115 < print
116 < '<WindowElementType>System</WindowElementType>
117 < <Optical>
118 < <Layer>
119 <        <Material>
120 <                <Name>Name</Name>
121 <                <Manufacturer>Manufacturer</Manufacturer>
122 < ';
123 < printf "\t\t<Thickness unit=\"$gunit\">%.3f</Thickness>\n", $dim[5] - $dim[4];
124 < printf "\t\t<Width unit=\"$gunit\">%.3f</Width>\n", $dim[1] - $dim[0];
125 < printf "\t\t<Height unit=\"$gunit\">%.3f</Height>\n", $dim[3] - $dim[2];
126 < print "\t\t<DeviceType>Integral</DeviceType>\n";
127 < # Output MGF description if requested
128 < if ( $geout ) {
129 <        print "\t\t<Geometry format=\"MGF\" unit=\"$gunit\">\n";
130 <        printf "xf -t %.6f %.6f 0\n", -($dim[0]+$dim[1])/2, -($dim[2]+$dim[3])/2;
131 <        open(MGFSCN, "< $mgfscn");
132 <        while (<MGFSCN>) { print $_; }
133 <        close MGFSCN;
134 <        print "xf\n";
135 <        print "\t\t</Geometry>\n";
136 < }
137 < print " </Material>\n";
138 < # Set up surface sampling
139 < my $nx = int(sqrt($nsamp*($dim[1]-$dim[0])/($dim[3]-$dim[2])) + .5);
140 < my $ny = int($nsamp/$nx + .5);
141 < $nsamp = $nx * $ny;
182 > # Assume Zmax==0 to derive thickness so pkgBSDF will work
183 > $wrapper .= ' -f "t=' . (-$dim[4]) . ';w=' . ($dim[1] - $dim[0]) .
184 >                ';h=' . ($dim[3] - $dim[2]) . '"';
185 > $wrapper .= " -g $mgfscn" if ( $geout );
186 > # Calculate CIE (u',v') from Radiance RGB:
187 > my $CIEuv =     'Xi=.5141*Ri+.3239*Gi+.1620*Bi;' .
188 >                'Yi=.2651*Ri+.6701*Gi+.0648*Bi;' .
189 >                'Zi=.0241*Ri+.1229*Gi+.8530*Bi;' .
190 >                'den=Xi+15*Yi+3*Zi;' .
191 >                'uprime=if(Yi,4*Xi/den,4/19);' .
192 >                'vprime=if(Yi,9*Yi/den,9/19);' ;
193 > my $FEPS = 1e-5;
194   my $ns = 2**$ttlog2;
195 < my (@pdiv, $disk2sq, $sq2disk, $tcal, $kcal);
195 > my $nx = int(sqrt($nsamp*($dim[1]-$dim[0])/($dim[3]-$dim[2])) + 1);
196 > my $ny = int($nsamp/$nx + 1);
197 > $nsamp = $nx * $ny;
198 > $rfluxmtx .= " -n $nproc -c $nsamp";
199 > if ( !defined $recovery ) {
200 >        open(MYAVH, "> $td/savedARGV.txt");
201 >        foreach (@savedARGV) {
202 >                print MYAVH "$_\n";
203 >        }
204 >        close MYAVH;
205 >        # Generate octree
206 >        system "oconv -w $radscn > $octree";
207 >        die "Could not compile scene\n" if ( $? );
208 >        # Add MGF description if requested
209 >        if ( $geout ) {
210 >                open(MGFSCN, "> $mgfscn");
211 >                printf MGFSCN "xf -t %.6f %.6f 0\n", -($dim[0]+$dim[1])/2, -($dim[2]+$dim[3])/2;
212 >                close MGFSCN;
213 >                if ( $mgfin ) {
214 >                        die "+mgf requires input file with +geom\n" if ($#ARGV < 0);
215 >                        system qq{mgfilt "#,o,xf,c,cxy,cspec,cmix,m,sides,rd,td,rs,ts,ir,v,p,n,f,fh,sph,cyl,cone,prism,ring,torus" @ARGV >> $mgfscn};
216 >                } else {
217 >                        system "rad2mgf $radscn >> $mgfscn";
218 >                }
219 >                open(MGFSCN, ">> $mgfscn");
220 >                print MGFSCN "xf\n";
221 >                close MGFSCN;
222 >        }
223 >        # Create receiver & sender surfaces (rectangular)
224 >        open(RADSCN, "> $receivers");
225 >        print RADSCN '#@rfluxmtx ' . ($tensortree ? "h=-sc$ns\n" : "h=-kf\n");
226 >        print RADSCN '#@rfluxmtx ' . "u=-Y o=$facedat\n\n";
227 >        print RADSCN "void glow receiver_face\n0\n0\n4 1 1 1 0\n\n";
228 >        print RADSCN "receiver_face source f_receiver\n0\n0\n4 0 0 1 180\n\n";
229 >        print RADSCN '#@rfluxmtx ' . ($tensortree ? "h=+sc$ns\n" : "h=+kf\n");
230 >        print RADSCN '#@rfluxmtx ' . "u=-Y o=$behinddat\n\n";
231 >        print RADSCN "void glow receiver_behind\n0\n0\n4 1 1 1 0\n\n";
232 >        print RADSCN "receiver_behind source b_receiver\n0\n0\n4 0 0 -1 180\n";
233 >        close RADSCN;
234 >        # Prepare sender surfaces
235 >        if ( $tensortree != 3 ) {       # Isotropic tensor tree is exception
236 >                open (RADSCN, "> $fsender");
237 >                print RADSCN '#@rfluxmtx u=-Y ' . ($tensortree ? "h=-sc$ns\n\n" : "h=-kf\n\n");
238 >                print RADSCN "void polygon fwd_sender\n0\n0\n12\n";
239 >                printf RADSCN "\t%e\t%e\t%e\n", $dim[0], $dim[2], $dim[4]-$FEPS;
240 >                printf RADSCN "\t%e\t%e\t%e\n", $dim[0], $dim[3], $dim[4]-$FEPS;
241 >                printf RADSCN "\t%e\t%e\t%e\n", $dim[1], $dim[3], $dim[4]-$FEPS;
242 >                printf RADSCN "\t%e\t%e\t%e\n", $dim[1], $dim[2], $dim[4]-$FEPS;
243 >                close RADSCN;
244 >                open (RADSCN, "> $bsender");
245 >                print RADSCN '#@rfluxmtx u=-Y ' . ($tensortree ? "h=+sc$ns\n\n" : "h=+kf\n\n");
246 >                print RADSCN "void polygon bwd_sender\n0\n0\n12\n";
247 >                printf RADSCN "\t%e\t%e\t%e\n", $dim[0], $dim[2], $dim[5]+$FEPS;
248 >                printf RADSCN "\t%e\t%e\t%e\n", $dim[1], $dim[2], $dim[5]+$FEPS;
249 >                printf RADSCN "\t%e\t%e\t%e\n", $dim[1], $dim[3], $dim[5]+$FEPS;
250 >                printf RADSCN "\t%e\t%e\t%e\n", $dim[0], $dim[3], $dim[5]+$FEPS;
251 >                close RADSCN;
252 >        }
253 >        print STDERR "Recover using: $0 -recover $td\n";
254 > }
255 > $curphase = 0;
256   # Create data segments (all the work happens here)
257   if ( $tensortree ) {
258          do_tree_bsdf();
259   } else {
260          do_matrix_bsdf();
261   }
262 < # Output XML epilogue
263 < print
264 < '</Layer>
265 < </Optical>
154 < </WindowElement>
155 < ';
262 > # Output XML
263 > # print STDERR "Running: $wrapper\n";
264 > system "$wrapper -C \"Created by: genBSDF @savedARGV\"";
265 > die "Could not wrap BSDF data\n" if ( $? );
266   # Clean up temporary files and exit
267 < exec("rm -rf $td");
267 > exec $rmtmp;
268  
269 < #-------------- End of main program segment --------------#
269 > #============== End of main program segment ==============#
270  
271 < #++++++++++++++ Kill persistent rtrace +++++++++++++++++++#
272 < sub persist_end {
273 <        if ( $persistfile && open(PFI, "< $persistfile") ) {
274 <                while (<PFI>) {
275 <                        s/^[^ ]* //;
276 <                        kill('ALRM', $_);
167 <                        last;
168 <                }
169 <                close PFI;
271 > # Function to determine if next phase should be skipped or recovered
272 > sub do_phase {
273 >        $curphase++;
274 >        if ( defined $recovery ) {
275 >                if ( $recovery > $curphase ) { return 0; }
276 >                if ( $recovery == $curphase ) { return -1; }
277          }
278 +        open(MYPH, ">> $td/phase.txt");
279 +        print MYPH "$curphase\n";
280 +        close MYPH;
281 +        return 1;
282   }
283  
284 < #++++++++++++++ Tensor tree BSDF generation ++++++++++++++#
285 < sub do_tree_bsdf {
286 < # Get sampling rate and subdivide task
287 < my $ns2 = $ns;
288 < $ns2 /= 2 if ( $tensortree == 3 );
178 < my $nsplice = $nproc;
179 < $nsplice *= 10 if ($nproc > 1);
180 < $nsplice = $ns2 if ($nsplice > $ns2);
181 < $nsplice = 999 if ($nsplice > 999);
182 < @pdiv = (0, int($ns2/$nsplice));
183 < my $nrem = $ns2 % $nsplice;
184 < for (my $i = 1; $i < $nsplice; $i++) {
185 <        my $nv = $pdiv[$i] + $pdiv[1];
186 <        ++$nv if ( $nrem-- > 0 );
187 <        push @pdiv, $nv;
188 < }
189 < die "Script error 1" if ($pdiv[-1] != $ns2);
190 < # Shirley-Chiu mapping from unit square to disk
191 < $sq2disk = '
192 < in_square_a = 2*in_square_x - 1;
193 < in_square_b = 2*in_square_y - 1;
194 < in_square_rgn = if(in_square_a + in_square_b,
195 <                        if(in_square_a - in_square_b, 1, 2),
196 <                        if(in_square_b - in_square_a, 3, 4));
197 < out_disk_r = .999995*select(in_square_rgn, in_square_a, in_square_b,
198 <                        -in_square_a, -in_square_b);
199 < out_disk_phi = PI/4 * select(in_square_rgn,
200 <                                in_square_b/in_square_a,
201 <                                2 - in_square_a/in_square_b,
202 <                                4 + in_square_b/in_square_a,
203 <                                if(in_square_b*in_square_b,
204 <                                        6 - in_square_a/in_square_b, 0));
205 < Dx = out_disk_r*cos(out_disk_phi);
206 < Dy = out_disk_r*sin(out_disk_phi);
207 < Dz = sqrt(1 - out_disk_r*out_disk_r);
208 < ';
209 < # Shirley-Chiu mapping from unit disk to square
210 < $disk2sq = '
211 < norm_radians(p) : if(-p - PI/4, p + 2*PI, p);
212 < in_disk_r = .999995*sqrt(Dx*Dx + Dy*Dy);
213 < in_disk_phi = norm_radians(atan2(Dy, Dx));
214 < in_disk_rgn = floor((in_disk_phi + PI/4)/(PI/2)) + 1;
215 < out_square_a = select(in_disk_rgn,
216 <                        in_disk_r,
217 <                        (PI/2 - in_disk_phi)*in_disk_r/(PI/4),
218 <                        -in_disk_r,
219 <                        (in_disk_phi - 3*PI/2)*in_disk_r/(PI/4));
220 < out_square_b = select(in_disk_rgn,
221 <                        in_disk_phi*in_disk_r/(PI/4),
222 <                        in_disk_r,
223 <                        (PI - in_disk_phi)*in_disk_r/(PI/4),
224 <                        -in_disk_r);
225 < out_square_x = (out_square_a + 1)/2;
226 < out_square_y = (out_square_b + 1)/2;
227 < ';
228 < # Announce ourselves in XML output
229 < print "\t<DataDefinition>\n";
230 < print "\t\t<IncidentDataStructure>TensorTree$tensortree</IncidentDataStructure>\n";
231 < print "\t</DataDefinition>\n";
232 < # Fork parallel rtcontrib processes to compute each side
233 < my $npleft = $nproc;
234 < if ( $doback ) {
235 <        for (my $splice = 0; $splice < $nsplice; $splice++) {
236 <                if (! $npleft ) {
237 <                        wait();
238 <                        die "rtcontrib process reported error" if ( $? );
239 <                        $npleft++;
240 <                }
241 <                bg_tree_rtcontrib(0, $splice);
242 <                $npleft--;
284 > # Check if we are in active phase (not skipping parts)
285 > sub active_phase {
286 >        if ( defined $recovery ) {
287 >                if ( $recovery > $curphase ) { return 0; }
288 >                if ( $recovery == $curphase ) { return -1; }
289          }
290 <        while (wait() >= 0) {
245 <                die "rtcontrib process reported error" if ( $? );
246 <                $npleft++;
247 <        }
248 <        persist_end();
249 <        ttree_out(0);
290 >        return 1;
291   }
292 < if ( $doforw ) {
293 <        for (my $splice = 0; $splice < $nsplice; $splice++) {
294 <                if (! $npleft ) {
295 <                        wait();
296 <                        die "rtcontrib process reported error" if ( $? );
297 <                        $npleft++;
298 <                }
299 <                bg_tree_rtcontrib(1, $splice);
259 <                $npleft--;
260 <        }
261 <        while (wait() >= 0) {
262 <                die "rtcontrib process reported error" if ( $? );
263 <                $npleft++;
264 <        }
265 <        persist_end();
266 <        ttree_out(1);
292 >
293 > # Function to run program and check output if in active phase
294 > sub run_check {
295 >        if ( !active_phase() ) { return; }
296 >        my $cmd = shift;
297 >        # print STDERR "Running: $cmd\n";
298 >        system $cmd;
299 >        die "Failure running: $cmd\n" if ( $? );
300   }
301 +
302 + #++++++++++++++ Tensor tree BSDF generation ++++++++++++++#
303 + sub do_tree_bsdf {
304 +
305 +        # Run rfluxmtx processes to compute each side
306 +        do_ttree_dir(0) if ( $doback );
307 +        do_ttree_dir(1) if ( $doforw );
308 +
309   }       # end of sub do_tree_bsdf()
310  
311 < # Run rtcontrib process in background to generate tensor tree samples
312 < sub bg_tree_rtcontrib {
272 <        my $pid = fork();
273 <        die "Cannot fork new process" unless defined $pid;
274 <        if ($pid > 0) { return $pid; }
311 > # Call rfluxmtx and process tensor tree BSDF for the given direction
312 > sub do_ttree_dir {
313          my $forw = shift;
314 <        my $pn = shift;
315 <        my $pbeg = $pdiv[$pn];
316 <        my $plen = $pdiv[$pn+1] - $pbeg;
279 <        my $matargs = "-m $bmodnm";
280 <        if ( !$forw || !$doback ) { $matargs .= " -m $fmodnm"; }
281 <        my $cmd = "rtcontrib $rtargs -h -ff -fo -c $nsamp " .
282 <                "-e '$disk2sq' -bn '$ns*$ns' " .
283 <                "-b '$ns*floor(out_square_x*$ns)+floor(out_square_y*$ns)' " .
284 <                "-o $td/%s_" . sprintf("%03d", $pn) . ".flt $matargs $octree";
314 >        my $dop = do_phase();
315 >        my $r = ($dop < 0) ? " -r" : "";
316 >        my $cmd;
317          if ( $tensortree == 3 ) {
318                  # Isotropic BSDF
319 <                $cmd = "cnt $plen $ny $nx " .
320 <                        "| rcalc -e 'r1=rand(($pn+.8681)*recno-.673892)' " .
321 <                        "-e 'r2=rand(($pn-5.37138)*recno+67.1737811)' " .
322 <                        "-e 'r3=rand(($pn+3.17603772)*recno+83.766771)' " .
323 <                        "-e 'Dx=1-2*($pbeg+\$1+r1)/$ns;Dy:0;Dz=sqrt(1-Dx*Dx)' " .
324 <                        "-e 'xp=(\$3+r2)*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
325 <                        "-e 'yp=(\$2+r3)*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
326 <                        "-e 'zp=$dim[5-$forw]' -e 'myDz=Dz*($forw*2-1)' " .
327 <                        "-e '\$1=xp-Dx;\$2=yp-Dy;\$3=zp-myDz' " .
328 <                        "-e '\$4=Dx;\$5=Dy;\$6=myDz' -of " .
329 <                        "| $cmd";
319 >                my $ns2 = $ns / 2;
320 >                if ($windoz) {
321 >                        $cmd = "cnt $ns2 $ny $nx " .
322 >                                qq{| rcalc -e "r1=rand(.8681*recno-.673892)" } .
323 >                                qq{-e "r2=rand(-5.37138*recno+67.1737811)" } .
324 >                                qq{-e "r3=rand(+3.17603772*recno+83.766771)" } .
325 >                                qq{-e "r4=rand(-1.5839226*recno-59.82712)" } .
326 >                                qq{-e "odds(n):if(.5*n-floor(.5*n)-.25,-1,1)"} .
327 >                                qq{-e "Dx=1-(\$1+r1)/$ns2" } .
328 >                                qq{-e "Dy=min(1/$ns,sqrt(1-Dx*Dx))*odds(\$1)*r2" } .
329 >                                qq{-e "Dz=sqrt(1-Dx*Dx-Dy*Dy)" } .
330 >                                qq{-e "xp=(\$3+r2)*(($dim[1]-$dim[0])/$nx)+$dim[0]" } .
331 >                                qq{-e "yp=(\$2+r3)*(($dim[3]-$dim[2])/$ny)+$dim[2]" } .
332 >                                qq{-e "zp=$dim[5-$forw]" -e "myDz=Dz*($forw*2-1)" } .
333 >                                qq{-e "\$1=xp-Dx;\$2=yp-Dy;\$3=zp-myDz" } .
334 >                                qq{-e "\$4=Dx;\$5=Dy;\$6=myDz" } .
335 >                                "| $rfluxmtx$r -fa -y $ns2 - $receivers -i $octree";
336 >                } else {
337 >                        $cmd = "cnt $ns2 $ny $nx " .
338 >                                qq{| rcalc -e 'r1=rand(.8681*recno-.673892)' } .
339 >                                qq{-e 'r2=rand(-5.37138*recno+67.1737811)' } .
340 >                                qq{-e 'r3=rand(+3.17603772*recno+83.766771)' } .
341 >                                qq{-e 'r4=rand(-1.5839226*recno-59.82712)' } .
342 >                                qq{-e 'odds(n):if(.5*n-floor(.5*n)-.25,-1,1)' } .
343 >                                qq{-e 'Dx=1-(\$1+r1)/$ns2' } .
344 >                                qq{-e 'Dy=min(1/$ns,sqrt(1-Dx*Dx))*odds(\$1)*r2' } .
345 >                                qq{-e 'Dz=sqrt(1-Dx*Dx-Dy*Dy)' } .
346 >                                qq{-e 'xp=(\$3+r3)*(($dim[1]-$dim[0])/$nx)+$dim[0]' } .
347 >                                qq{-e 'yp=(\$2+r4)*(($dim[3]-$dim[2])/$ny)+$dim[2]' } .
348 >                                qq{-e 'zp=$dim[5-$forw]' -e 'myDz=Dz*($forw*2-1)' } .
349 >                                qq{-e '\$1=xp-Dx;\$2=yp-Dy;\$3=zp-myDz' } .
350 >                                qq{-e '\$4=Dx;\$5=Dy;\$6=myDz' -of } .
351 >                                "| $rfluxmtx$r -h -ff -y $ns2 - $receivers -i $octree";
352 >                }
353          } else {
354                  # Anisotropic BSDF
355 <                # Sample area vertically to improve load balance, since
356 <                # shading systems usually have bilateral symmetry (L-R)
357 <                $cmd = "cnt $plen $ns $ny $nx " .
358 <                        "| rcalc -e 'r1=rand(($pn+.8681)*recno-.673892)' " .
359 <                        "-e 'r2=rand(($pn-5.37138)*recno+67.1737811)' " .
360 <                        "-e 'r3=rand(($pn+3.17603772)*recno+83.766771)' " .
306 <                        "-e 'r4=rand(($pn-2.3857833)*recno-964.72738)' " .
307 <                        "-e 'in_square_x=($pbeg+\$1+r1)/$ns' " .
308 <                        "-e 'in_square_y=(\$2+r2)/$ns' -e '$sq2disk' " .
309 <                        "-e 'xp=(\$4+r3)*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
310 <                        "-e 'yp=(\$3+r4)*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
311 <                        "-e 'zp=$dim[5-$forw]' -e 'myDz=Dz*($forw*2-1)' " .
312 <                        "-e '\$1=xp-Dx;\$2=yp-Dy;\$3=zp-myDz' " .
313 <                        "-e '\$4=Dx;\$5=Dy;\$6=myDz' -of " .
314 <                        "| $cmd";
355 >                my $sender = ($bsender,$fsender)[$forw];
356 >                if ($windoz) {
357 >                        $cmd = "$rfluxmtx$r -fa $sender $receivers -i $octree";
358 >                } else {
359 >                        $cmd = "$rfluxmtx$r -h -ff $sender $receivers -i $octree";
360 >                }
361          }
362 < # print STDERR "Starting: $cmd\n";
363 <        exec($cmd);             # no return; status report to parent via wait
364 <        die "Cannot exec: $cmd\n";
365 < }       # end of bg_tree_rtcontrib()
362 >        if ( $dop ) {
363 >                # print STDERR "Running: $cmd\n";
364 >                system $cmd;
365 >                die "Failure running rfluxmtx" if ( $? );
366 >        }
367 >        ttree_out($forw);
368 > }       # end of do_ttree_dir()
369  
370 < # Simplify and output tensor tree results
370 > # Simplify and store tensor tree results
371   sub ttree_out {
372          my $forw = shift;
373 <        my $side = ("Back","Front")[$forw];
374 <        my $cmd;
375 < # Only output one transmitted distribution, preferring backwards
376 < if ( !$forw || !$doback ) {
377 < print
378 < '       <WavelengthData>
379 <                <LayerNumber>System</LayerNumber>
331 <                <Wavelength unit="Integral">Visible</Wavelength>
332 <                <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
333 <                <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
334 <                <WavelengthDataBlock>
335 <                        <WavelengthDataDirection>Transmission</WavelengthDataDirection>
336 <                        <AngleBasis>LBNL/Shirley-Chiu</AngleBasis>
337 <                        <ScatteringDataType>BTDF</ScatteringDataType>
338 <                        <ScatteringData>
339 < ';
340 < $cmd = "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
341 <        q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' };
342 < if ($pctcull >= 0) {
343 <        $cmd .= "-of $td/" . ($bmodnm,$fmodnm)[$forw] . "_???.flt " .
344 <        "| rttree_reduce -a -h -ff -t $pctcull -r $tensortree -g $ttlog2";
345 <        system "$cmd" || die "Failure running rttree_reduce";
346 < } else {
347 <        $cmd .= "$td/" . ($bmodnm,$fmodnm)[$forw] . "_???.flt";
348 <        print "{\n";
349 <        system "$cmd" || die "Failure running rcalc";
350 <        for (my $i = ($tensortree==3)*$ns*$ns*$ns/2; $i-- > 0; ) {
351 <                print "0\n";
373 >        my ($refldat,$transdat);
374 >        if ( $forw ) {
375 >                $transdat = $facedat;
376 >                $refldat = $behinddat;
377 >        } else {
378 >                $transdat = $behinddat;
379 >                $refldat = $facedat;
380          }
381 <        print "}\n";
382 < }
383 < print
384 < '                       </ScatteringData>
385 <                </WavelengthDataBlock>
386 <        </WavelengthData>
387 < ';
388 < }
361 < # Output reflection
362 < print
363 < '       <WavelengthData>
364 <                <LayerNumber>System</LayerNumber>
365 <                <Wavelength unit="Integral">Visible</Wavelength>
366 <                <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
367 <                <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
368 <                <WavelengthDataBlock>
369 < ';
370 < print "\t\t\t<WavelengthDataDirection>Reflection $side</WavelengthDataDirection>\n";
371 < print
372 < '                       <AngleBasis>LBNL/Shirley-Chiu</AngleBasis>
373 <                        <ScatteringDataType>BRDF</ScatteringDataType>
374 <                        <ScatteringData>
375 < ';
376 < $cmd = "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
377 <        q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' };
378 < if ($pctcull >= 0) {
379 <        $cmd .= "-of $td/" . ($fmodnm,$bmodnm)[$forw] . "_???.flt " .
380 <        "| rttree_reduce -a -h -ff -t $pctcull -r $tensortree -g $ttlog2";
381 <        system "$cmd" || die "Failure running rttree_reduce";
382 < } else {
383 <        $cmd .= "$td/" . ($fmodnm,$bmodnm)[$forw] . "_???.flt";
384 <        print "{\n";
385 <        system "$cmd" || die "Failure running rcalc";
386 <        for (my $i = ($tensortree==3)*$ns*$ns*$ns/2; $i-- > 0; ) {
387 <                print "0\n";
381 >        # Only output one transmitted anisotropic distribution, preferring backwards
382 >        if ( !$forw || !$doback || $tensortree==3 ) {
383 >                my $ttyp = ("tb","tf")[$forw];
384 >                ttree_comp($ttyp, "Visible", $transdat, ($tb,$tf)[$forw]);
385 >                if ( $docolor ) {
386 >                        ttree_comp($ttyp, "CIE-u", $transdat, ($tbx,$tfx)[$forw]);
387 >                        ttree_comp($ttyp, "CIE-v", $transdat, ($tbz,$tfz)[$forw]);
388 >                }
389          }
390 <        print "}\n";
391 < }
392 < print
393 < '                       </ScatteringData>
394 <                </WavelengthDataBlock>
395 <        </WavelengthData>
396 < ';
390 >        # Output reflection
391 >        my $rtyp = ("rb","rf")[$forw];
392 >        ttree_comp($rtyp, "Visible", $refldat, ($rb,$rf)[$forw]);
393 >        if ( $docolor ) {
394 >                ttree_comp($rtyp, "CIE-u", $refldat, ($rbx,$rfx)[$forw]);
395 >                ttree_comp($rtyp, "CIE-v", $refldat, ($rbz,$rfz)[$forw]);
396 >        }
397   }       # end of ttree_out()
398  
399 + # Call rttree_reduce on the given component
400 + sub ttree_comp {
401 +        my $typ = shift;
402 +        my $spec = shift;
403 +        my $src = shift;
404 +        my $dest = shift;
405 +        my $cmd;
406 +        if ($windoz) {
407 +                if ("$spec" eq "Visible") {
408 +                        $cmd = qq{rcalc -e "Omega:PI/($ns*$ns)" } .
409 +                                q{-e "Ri=$1;Gi=$2;Bi=$3" } .
410 +                                qq{-e "$CIEuv" } .
411 +                                q{-e "$1=Yi/Omega"};
412 +                } elsif ("$spec" eq "CIE-u") {
413 +                        $cmd = q{rcalc -e "Ri=$1;Gi=$2;Bi=$3" } .
414 +                                qq{-e "$CIEuv" } .
415 +                                q{-e "$1=uprime"};
416 +                } elsif ("$spec" eq "CIE-v") {
417 +                        $cmd = q{rcalc -e "Ri=$1;Gi=$2;Bi=$3" } .
418 +                                qq{-e "$CIEuv" } .
419 +                                q{-e "$1=vprime"};
420 +                }
421 +        } else {
422 +                if ("$spec" eq "Visible") {
423 +                        $cmd = "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
424 +                                q{-e 'Ri=$1;Gi=$2;Bi=$3' } .
425 +                                "-e '$CIEuv' " .
426 +                                q{-e '$1=Yi/Omega'};
427 +                } elsif ("$spec" eq "CIE-u") {
428 +                        $cmd = q{rcalc -if3 -e 'Ri=$1;Gi=$2;Bi=$3' } .
429 +                                "-e '$CIEuv' " .
430 +                                q{-e '$1=uprime'};
431 +                } elsif ("$spec" eq "CIE-v") {
432 +                        $cmd = q{rcalc -if3 -e 'Ri=$1;Gi=$2;Bi=$3' } .
433 +                                "-e '$CIEuv' " .
434 +                                q{-e '$1=vprime'};
435 +                }
436 +        }
437 +        if ($pctcull >= 0) {
438 +                my $avg = ( $dorecip && ( $tensortree == 3 || "$typ" =~ /^r[fb]/ ) ) ? " -a" : "";
439 +                my $pcull = ("$spec" eq "Visible") ? $pctcull :
440 +                                                     (100 - (100-$pctcull)*.25) ;
441 +                if ($windoz) {
442 +                        $cmd = "rcollate -ho -oc 1 $src | " .
443 +                                        $cmd .
444 +                                        " | rttree_reduce$avg -h -fa -t $pcull -r $tensortree -g $ttlog2";
445 +                } else {
446 +                        $cmd .= " -of $src " .
447 +                                        "| rttree_reduce$avg -h -ff -t $pcull -r $tensortree -g $ttlog2";
448 +                }
449 +                run_check "$cmd > $dest";
450 +        } else {
451 +                if ($windoz) {
452 +                        $cmd = "rcollate -ho -oc 1 $src | " . $cmd ;
453 +                } else {
454 +                        $cmd .= " $src";
455 +                }
456 +                if ( active_phase() ) {
457 +                        open(DATOUT, "> $dest");
458 +                        print DATOUT "{\n";
459 +                        close DATOUT;
460 +                        # print STDERR "Running: $cmd\n";
461 +                        system "$cmd >> $dest";
462 +                        die "Failure running rcalc" if ( $? );
463 +                        open(DATOUT, ">> $dest");
464 +                        for (my $i = ($tensortree==3)*$ns*$ns*$ns/2; $i-- > 0; ) {
465 +                                print DATOUT "0\n";
466 +                        }
467 +                        print DATOUT "}\n";
468 +                        close DATOUT;
469 +                }
470 +        }
471 +        if ( "$spec" ne "$curspec" ) {
472 +                $wrapper .= " -s $spec";
473 +                $curspec = $spec;
474 +        }
475 +        $wrapper .= " -$typ $dest";
476 + }       # end of ttree_comp()
477 +
478   #------------- End of do_tree_bsdf() & subroutines -------------#
479  
480   #+++++++++++++++ Klems matrix BSDF generation +++++++++++++++#
481   sub do_matrix_bsdf {
482 < # Set up sampling of portal
483 < # Kbin to produce incident direction in full Klems basis with (x1,x2) randoms
484 < $tcal = '
485 < DEGREE : PI/180;
486 < sq(x) : x*x;
487 < Kpola(r) : select(r+1, 0, 5, 15, 25, 35, 45, 55, 65, 75, 90);
488 < Knaz(r) : select(r, 1, 8, 16, 20, 24, 24, 24, 16, 12);
489 < Kaccum(r) : if(r-.5, Knaz(r) + Kaccum(r-1), 0);
490 < Kmax : Kaccum(Knaz(0));
491 < Kfindrow(r, rem) : if(rem-Knaz(r)+.5, Kfindrow(r+1, rem-Knaz(r)), r);
492 < Krow = if(Kbin-(Kmax-.5), 0, Kfindrow(1, Kbin));
493 < Kcol = Kbin - Kaccum(Krow-1);
494 < Kazi = 360*DEGREE * (Kcol + (.5 - x2)) / Knaz(Krow);
495 < Kpol = DEGREE * (x1*Kpola(Krow) + (1-x1)*Kpola(Krow-1));
496 < sin_kpol = sin(Kpol);
497 < Dx = cos(Kazi)*sin_kpol;
498 < Dy = sin(Kazi)*sin_kpol;
499 < Dz = sqrt(1 - sin_kpol*sin_kpol);
420 < KprojOmega = PI * if(Kbin-.5,
421 <        (sq(cos(Kpola(Krow-1)*DEGREE)) - sq(cos(Kpola(Krow)*DEGREE)))/Knaz(Krow),
422 <        1 - sq(cos(Kpola(1)*DEGREE)));
423 < ';
424 < # Compute Klems bin from exiting ray direction (forward or backward)
425 < $kcal = '
426 < DEGREE : PI/180;
427 < abs(x) : if(x, x, -x);
428 < Acos(x) : if(x-1, 0, if(-1-x, PI, acos(x))) / DEGREE;
429 < posangle(a) : if(-a, a + 2*PI, a);
430 < Atan2(y,x) : posangle(atan2(y,x)) / DEGREE;
431 < kpola(r) : select(r, 5, 15, 25, 35, 45, 55, 65, 75, 90);
432 < knaz(r) : select(r, 1, 8, 16, 20, 24, 24, 24, 16, 12);
433 < kaccum(r) : if(r-.5, knaz(r) + kaccum(r-1), 0);
434 < kfindrow(r, pol) : if(r-kpola(0)+.5, r,
435 <                if(pol-kpola(r), kfindrow(r+1, pol), r) );
436 < kazn(azi,inc) : if((360-.5*inc)-azi, floor((azi+.5*inc)/inc), 0);
437 < kbin2(pol,azi) = select(kfindrow(1, pol),
438 <                kazn(azi,360/knaz(1)),
439 <                kaccum(1) + kazn(azi,360/knaz(2)),
440 <                kaccum(2) + kazn(azi,360/knaz(3)),
441 <                kaccum(3) + kazn(azi,360/knaz(4)),
442 <                kaccum(4) + kazn(azi,360/knaz(5)),
443 <                kaccum(5) + kazn(azi,360/knaz(6)),
444 <                kaccum(6) + kazn(azi,360/knaz(7)),
445 <                kaccum(7) + kazn(azi,360/knaz(8)),
446 <                kaccum(8) + kazn(azi,360/knaz(9))
447 <        );
448 < kbin = kbin2(Acos(abs(Dz)),Atan2(Dy,Dx));
449 < ';
450 < my $ndiv = 145;
451 < # Compute scattering data using rtcontrib
452 < my @tfarr;
453 < my @rfarr;
454 < my @tbarr;
455 < my @rbarr;
456 < my $cmd;
457 < my $rtcmd = "rtcontrib $rtargs -h -ff -fo -n $nproc -c $nsamp " .
458 <        "-e '$kcal' -b kbin -bn $ndiv " .
459 <        "-o '$td/%s.flt' -m $fmodnm -m $bmodnm $octree";
460 < my $rccmd = "rcalc -e '$tcal' " .
461 <        "-e 'mod(n,d):n-floor(n/d)*d' -e 'Kbin=mod(recno-.999,$ndiv)' " .
462 <        q{-if3 -e '$1=(0.265*$1+0.670*$2+0.065*$3)/KprojOmega' };
463 < if ( $doforw ) {
464 < $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
465 <        "-e 'xp=(\$3+rand(.12*recno+288))*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
466 <        "-e 'yp=(\$2+rand(.37*recno-44))*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
467 <        "-e 'zp:$dim[4]' " .
468 <        q{-e 'Kbin=$1;x1=rand(2.75*recno+3.1);x2=rand(-2.01*recno-3.37)' } .
469 <        q{-e '$1=xp-Dx;$2=yp-Dy;$3=zp-Dz;$4=Dx;$5=Dy;$6=Dz' } .
470 <        "| $rtcmd";
471 < system "$cmd" || die "Failure running: $cmd\n";
472 < @tfarr = `$rccmd $td/$fmodnm.flt`;
473 < die "Failure running: $rccmd $td/$fmodnm.flt\n" if ( $? );
474 < @rfarr = `$rccmd $td/$bmodnm.flt`;
475 < die "Failure running: $rccmd $td/$bmodnm.flt\n" if ( $? );
476 < }
477 < if ( $doback ) {
478 < $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
479 <        "-e 'xp=(\$3+rand(.35*recno-15))*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
480 <        "-e 'yp=(\$2+rand(.86*recno+11))*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
481 <        "-e 'zp:$dim[5]' " .
482 <        q{-e 'Kbin=$1;x1=rand(1.21*recno+2.75);x2=rand(-3.55*recno-7.57)' } .
483 <        q{-e '$1=xp-Dx;$2=yp-Dy;$3=zp+Dz;$4=Dx;$5=Dy;$6=-Dz' } .
484 <        "| $rtcmd";
485 < system "$cmd" || die "Failure running: $cmd\n";
486 < @tbarr = `$rccmd $td/$bmodnm.flt`;
487 < die "Failure running: $rccmd $td/$bmodnm.flt\n" if ( $? );
488 < chomp(@tbarr);
489 < @rbarr = `$rccmd $td/$fmodnm.flt`;
490 < die "Failure running: $rccmd $td/$fmodnm.flt\n" if ( $? );
491 < chomp(@rbarr);
492 < }
493 < # Output angle basis
494 < print
495 < '       <DataDefinition>
496 <                <IncidentDataStructure>Columns</IncidentDataStructure>
497 <                <AngleBasis>
498 <                        <AngleBasisName>LBNL/Klems Full</AngleBasisName>
499 <                        <AngleBasisBlock>
500 <                        <Theta>0</Theta>
501 <                        <nPhis>1</nPhis>
502 <                        <ThetaBounds>
503 <                                <LowerTheta>0</LowerTheta>
504 <                                <UpperTheta>5</UpperTheta>
505 <                        </ThetaBounds>
506 <                        </AngleBasisBlock>
507 <                        <AngleBasisBlock>
508 <                        <Theta>10</Theta>
509 <                        <nPhis>8</nPhis>
510 <                        <ThetaBounds>
511 <                                <LowerTheta>5</LowerTheta>
512 <                                <UpperTheta>15</UpperTheta>
513 <                        </ThetaBounds>
514 <                        </AngleBasisBlock>
515 <                        <AngleBasisBlock>
516 <                        <Theta>20</Theta>
517 <                        <nPhis>16</nPhis>
518 <                        <ThetaBounds>
519 <                                <LowerTheta>15</LowerTheta>
520 <                                <UpperTheta>25</UpperTheta>
521 <                        </ThetaBounds>
522 <                        </AngleBasisBlock>
523 <                        <AngleBasisBlock>
524 <                        <Theta>30</Theta>
525 <                        <nPhis>20</nPhis>
526 <                        <ThetaBounds>
527 <                                <LowerTheta>25</LowerTheta>
528 <                                <UpperTheta>35</UpperTheta>
529 <                        </ThetaBounds>
530 <                        </AngleBasisBlock>
531 <                        <AngleBasisBlock>
532 <                        <Theta>40</Theta>
533 <                        <nPhis>24</nPhis>
534 <                        <ThetaBounds>
535 <                                <LowerTheta>35</LowerTheta>
536 <                                <UpperTheta>45</UpperTheta>
537 <                        </ThetaBounds>
538 <                        </AngleBasisBlock>
539 <                        <AngleBasisBlock>
540 <                        <Theta>50</Theta>
541 <                        <nPhis>24</nPhis>
542 <                        <ThetaBounds>
543 <                                <LowerTheta>45</LowerTheta>
544 <                                <UpperTheta>55</UpperTheta>
545 <                        </ThetaBounds>
546 <                        </AngleBasisBlock>
547 <                        <AngleBasisBlock>
548 <                        <Theta>60</Theta>
549 <                        <nPhis>24</nPhis>
550 <                        <ThetaBounds>
551 <                                <LowerTheta>55</LowerTheta>
552 <                                <UpperTheta>65</UpperTheta>
553 <                        </ThetaBounds>
554 <                        </AngleBasisBlock>
555 <                        <AngleBasisBlock>
556 <                        <Theta>70</Theta>
557 <                        <nPhis>16</nPhis>
558 <                        <ThetaBounds>
559 <                                <LowerTheta>65</LowerTheta>
560 <                                <UpperTheta>75</UpperTheta>
561 <                        </ThetaBounds>
562 <                        </AngleBasisBlock>
563 <                        <AngleBasisBlock>
564 <                        <Theta>82.5</Theta>
565 <                        <nPhis>12</nPhis>
566 <                        <ThetaBounds>
567 <                                <LowerTheta>75</LowerTheta>
568 <                                <UpperTheta>90</UpperTheta>
569 <                        </ThetaBounds>
570 <                        </AngleBasisBlock>
571 <                </AngleBasis>
572 <        </DataDefinition>
573 < ';
574 < if ( $doforw ) {
575 < print
576 < '       <WavelengthData>
577 <                <LayerNumber>System</LayerNumber>
578 <                <Wavelength unit="Integral">Visible</Wavelength>
579 <                <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
580 <                <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
581 <                <WavelengthDataBlock>
582 <                        <WavelengthDataDirection>Transmission Front</WavelengthDataDirection>
583 <                        <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
584 <                        <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
585 <                        <ScatteringDataType>BTDF</ScatteringDataType>
586 <                        <ScatteringData>
587 < ';
588 < # Output front transmission (transposed order)
589 < for (my $od = 0; $od < $ndiv; $od++) {
590 <        for (my $id = 0; $id < $ndiv; $id++) {
591 <                print $tfarr[$ndiv*$id + $od], ",\n";
482 >
483 >        # Run rfluxmtx processes to compute each side
484 >        do_matrix_dir(0) if ( $doback );
485 >        do_matrix_dir(1) if ( $doforw );
486 >
487 > }       # end of sub do_matrix_bsdf()
488 >
489 > # Call rfluxmtx and process tensor tree BSDF for the given direction
490 > sub do_matrix_dir {
491 >        my $forw = shift;
492 >        my $dop = do_phase();
493 >        my $r = ($dop < 0) ? " -r" : "";
494 >        my $sender = ($bsender,$fsender)[$forw];
495 >        my $cmd = "$rfluxmtx$r -fd $sender $receivers -i $octree";
496 >        if ( $dop ) {
497 >                # print STDERR "Running: $cmd\n";
498 >                system $cmd;
499 >                die "Failure running rfluxmtx" if ( $? );
500          }
501 <        print "\n";
502 < }
503 < print
504 < '                       </ScatteringData>
505 <                </WavelengthDataBlock>
506 <        </WavelengthData>
507 <        <WavelengthData>
508 <                <LayerNumber>System</LayerNumber>
509 <                <Wavelength unit="Integral">Visible</Wavelength>
510 <                <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
511 <                <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
512 <                <WavelengthDataBlock>
605 <                        <WavelengthDataDirection>Reflection Front</WavelengthDataDirection>
606 <                        <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
607 <                        <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
608 <                        <ScatteringDataType>BRDF</ScatteringDataType>
609 <                        <ScatteringData>
610 < ';
611 < # Output front reflection (transposed order)
612 < for (my $od = 0; $od < $ndiv; $od++) {
613 <        for (my $id = 0; $id < $ndiv; $id++) {
614 <                print $rfarr[$ndiv*$id + $od], ",\n";
501 >        matrix_out($forw);
502 > }       # end of do_matrix_dir()
503 >
504 > sub matrix_out {
505 >        my $forw = shift;
506 >        my ($refldat,$transdat);
507 >        if ( $forw ) {
508 >                $transdat = $facedat;
509 >                $refldat = $behinddat;
510 >        } else {
511 >                $transdat = $behinddat;
512 >                $refldat = $facedat;
513          }
514 <        print "\n";
515 < }
516 < print
517 < '                       </ScatteringData>
518 <                </WavelengthDataBlock>
519 <        </WavelengthData>
622 < ';
623 < }
624 < if ( $doback ) {
625 < print
626 < '       <WavelengthData>
627 <                <LayerNumber>System</LayerNumber>
628 <                <Wavelength unit="Integral">Visible</Wavelength>
629 <                <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
630 <                <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
631 <                <WavelengthDataBlock>
632 <                        <WavelengthDataDirection>Transmission Back</WavelengthDataDirection>
633 <                        <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
634 <                        <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
635 <                        <ScatteringDataType>BTDF</ScatteringDataType>
636 <                        <ScatteringData>
637 < ';
638 < # Output back transmission (transposed order)
639 < for (my $od = 0; $od < $ndiv; $od++) {
640 <        for (my $id = 0; $id < $ndiv; $id++) {
641 <                print $tbarr[$ndiv*$id + $od], ",\n";
514 >        # Output transmission
515 >        my $ttyp = ("tb","tf")[$forw];
516 >        matrix_comp($ttyp, "Visible", $transdat, ($tb,$tf)[$forw]);
517 >        if ( $docolor ) {
518 >                matrix_comp($ttyp, "CIE-X", $transdat, ($tbx,$tfx)[$forw]);
519 >                matrix_comp($ttyp, "CIE-Z", $transdat, ($tbz,$tfz)[$forw]);
520          }
521 <        print "\n";
522 < }
523 < print
524 < '                       </ScatteringData>
525 <                </WavelengthDataBlock>
526 <        </WavelengthData>
649 <        <WavelengthData>
650 <                <LayerNumber>System</LayerNumber>
651 <                <Wavelength unit="Integral">Visible</Wavelength>
652 <                <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
653 <                <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
654 <                <WavelengthDataBlock>
655 <                        <WavelengthDataDirection>Reflection Back</WavelengthDataDirection>
656 <                        <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
657 <                        <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
658 <                        <ScatteringDataType>BRDF</ScatteringDataType>
659 <                        <ScatteringData>
660 < ';
661 < # Output back reflection (transposed order)
662 < for (my $od = 0; $od < $ndiv; $od++) {
663 <        for (my $id = 0; $id < $ndiv; $id++) {
664 <                print $rbarr[$ndiv*$id + $od], ",\n";
521 >        # Output reflection
522 >        my $rtyp = ("rb","rf")[$forw];
523 >        matrix_comp($rtyp, "Visible", $refldat, ($rb,$rf)[$forw]);
524 >        if ( $docolor ) {
525 >                matrix_comp($rtyp, "CIE-X", $refldat, ($rbx,$rfx)[$forw]);
526 >                matrix_comp($rtyp, "CIE-Z", $refldat, ($rbz,$rfz)[$forw]);
527          }
528 <        print "\n";
529 < }
530 < print
531 < '                       </ScatteringData>
532 <                </WavelengthDataBlock>
533 <        </WavelengthData>
534 < ';
535 < }
536 < }
537 < #------------- End of do_matrix_bsdf() --------------#
528 > }       # end of matrix_out()
529 >
530 > # Transpose matrix component data and save to file
531 > sub matrix_comp {
532 >        my $typ = shift;
533 >        my $spec = shift;
534 >        my $src = shift;
535 >        my $dest = shift;
536 >        my $cmd = "rmtxop -fa -t";
537 >        if ("$spec" eq "Visible") {
538 >                $cmd .= " -c 0.2651 0.6701 0.0648";
539 >        } elsif ("$spec" eq "CIE-X") {
540 >                $cmd .= " -c 0.5141 0.3239 0.1620";
541 >        } elsif ("$spec" eq "CIE-Z") {
542 >                $cmd .= " -c 0.0241 0.1229 0.8530";
543 >        }
544 >        $cmd .= " $src | getinfo -";
545 >        run_check "$cmd > $dest";
546 >        if ( "$spec" ne "$curspec" ) {
547 >                $wrapper .= " -s $spec";
548 >                $curspec = $spec;
549 >        }
550 >        $wrapper .= " -$typ $dest";
551 > }       # end of matrix_comp()
552 >
553 > #------------- End of do_matrix_bsdf() & subroutines --------------#

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines